Attack = {}

bases = Bases:getBases()

local ships = {}
local attacks = {}
local movements = {}
  
function Attack:attack(startingBase, endingBase, units) -- this is the start of the attack
  if units == 0 then return end 
  local id = #movements + 1
  local movement = {id = id, startBase = startingBase, endBase = endingBase, units = units}
  --if bases[startingBase].owner == 1 then print("id is: " .. id) end
  table.insert(movements, id, movement) -- insert attack at the end of the attacks table
  
  bases[startingBase].attacking = false
  
  if bases[startingBase].owner == 1 then 
    selectedUnits = 0
  end
end


local timer = 10
function Attack:update(dt)
  for _,movement in ipairs(movements) do
    if movement.units > 0 then
      if timer <= 0 then
        movement.units = movement.units - 10
        Attack:drawShips(movement.id)
        timer = 10
      else
        timer = timer - 1
      end
    else
      ---table.remove(movements,movement.id)
    end
  
  end
end

function Attack:drawShips(id)
  local n = #ships + 1
  ships[n] = { x = bases[movements[id].startBase].body:getX() + tx, y = bases[movements[id].startBase].body:getY() + ty, units = units, radius = 4, color = bases[movements[id].startBase].color, alpha = 255, timer = .25, startingTX = tx, startingTY = ty}
  flux.to(ships[n], ships[n].timer, { x = bases[movements[id].endBase].body:getX() + tx, y = bases[movements[id].endBase].body:getY() + ty })
    :onupdate(function() 
        if ships[n].startingTX ~= tx then
          ships[n].x = ships[n].x - ships[n].startingTX + tx
          ships[n].y = ships[n].y - ships[n].startingTY + ty
          ships[n].startingTX = tx
          ships[n].startingTY = ty
        end
        --flux.to(ships[n], ships[n].timer, { x = bases[movements[id].endBase].body:getX() + tx, y = bases[movements[id].endBase].body:getY() + ty }) 
        ships[n].timer = ships[n].timer - love.timer.getDelta()
        --print(ships[n].timer)
        end)
    :oncomplete(function() Attack:resolveAttack(id) end)
    :after(ships[n], 2, { alpha = 0 })
end

function Attack:resolveAttack(id)
  --if bases[attacks[id].startBase].owner == 1 then print("id is: " .. id) end
  --print(bases[attacks[id].endBase].defenseMod)
  if bases[movements[id].endBase].owner == bases[movements[id].startBase].owner then-- already our base
    bases[movements[id].endBase].units = bases[movements[id].endBase].units + 10
  elseif 10 > bases[movements[id].endBase].units * bases[movements[id].endBase].defenseMod then -- attackers win
    bases[movements[id].endBase].owner = bases[movements[id].startBase].owner
    bases[movements[id].endBase].color, bases[movements[id].endBase].secondaryColor = bases[movements[id].startBase].color, bases[movements[id].startBase].secondaryColor
    bases[movements[id].endBase].units = 10 - bases[movements[id].endBase].units
  elseif 10 <= bases[movements[id].endBase].units * bases[movements[id].endBase].defenseMod then -- defense wins
    bases[movements[id].endBase].units = bases[movements[id].endBase].units - 10
  end    
  bases[movements[id].startBase].attacking = false
end
function Attack:draw()
  --for _,attack in ipairs(attacks) do
    if #ships > 0 then
      for _,ship in ipairs(ships) do
        --love.graphics.printf(ship.units, ship.x -tx + 10, ship.y -ty - 15, 50, "center")
        r,g,b = unpack(ship.color)
        love.graphics.setColor(r,g,b, ship.alpha)
        --love.graphics.setColor(255,255,255)
        love.graphics.circle("fill", ship.x -tx, ship.y - ty, ship.radius)
      end
    end
  --end
end

return Attack