window_width, window_height = love.graphics.getDimensions()

require "requires"

DEBUG = false
PAUSED = -1
tx = 0
ty = 0
selectedPositionX = 0
selectedPositionY = 0
selectedBase = 0
selectedUnits = 0
scaleX, scaleY = 1, 1

function love.load()
  print("Thank you for trying my game! -- MTDev")
  large = love.graphics.newFont(96)
  small = love.graphics.newFont(12)
  world = love.physics.newWorld(0,0,1)
  Bases:load()
  Player:load()
  AI:load()
  UI:load()
  love.mouse.setVisible(false)
end

function love.update(dt)
  if PAUSED ~= 1 then
    Bases:update(dt)
    Player:update(dt)
    Movement:update(dt)
    Attack:update(dt)
    AI:update(dt)
    UI:update(dt)
    flux.update(dt)
    --print(love.mouse.getPosition())
    if love.mouse.getX() >= love.graphics.getWidth() / scaleX - 10 and love.mouse.getX() < love.graphics.getWidth() / scaleX - 1 then
      selectedPositionX = selectedPositionX + 1
    elseif love.mouse.getX() <= 10 and love.mouse.getX() >= 1 then
      selectedPositionX = selectedPositionX - 1
    end

    if love.mouse.getY() <= 10 and love.mouse.getY() >= 1 then
      selectedPositionY = selectedPositionY - 1
    elseif love.mouse.getY() >= love.graphics.getHeight() / scaleY - 10 and love.mouse.getY() < love.graphics.getHeight() / scaleY - 1 then
      selectedPositionY = selectedPositionY + 1
    end
  end
end

function love.draw()
  UI:draw()  
  --print(love.mouse.getX(), love.mouse.getY())
  love.graphics.scale(scaleX, scaleY)
  love.graphics.push()
  tx, ty = math.floor(-selectedPositionX + (window_width / scaleX) / 2), math.floor(-selectedPositionY + (window_height / scaleY) / 2 )    
  love.graphics.translate(tx, ty)
  
  --print(love.mouse.getX(), love.mouse.getY())
  Movement:draw()
  Attack.draw()
  Bases:draw()
  AI:draw()
  
  if PAUSED == 1 then
    love.graphics.setFont(large)
    love.graphics.printf("PAUSED",  -tx, window_height /3 -ty, window_width, "center")
    love.graphics.setFont(small)
  end
  
  love.graphics.pop()
  love.graphics.setColor(255,255,255,255)
  if selectedUnits > 0 then love.graphics.setColor(0,0,255) end
  love.graphics.circle( "fill", love.mouse.getX(), love.mouse.getY(), 5 )


  --if selectedUnits > 0 then love.graphics.printf(selectedUnits, love.mouse.getX(), love.mouse.getY(), 30, "center") end
  if DEBUG then
    love.graphics.setColor(255,255,255,255)
    love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
  end
end