Movement = {}

local movements = {}
local movement = {}
local ships = {}

function Movement:setMovingUnits(id)
  if selectedBase == id and bases[id].hovering == true and bases[id].attacking == false then
    selectedUnits = math.floor(bases[id].units / 2)
    bases[id].units = math.ceil(bases[id].units / 2)
    bases[id].attacking = true
  end
end

function Movement:moveUnits(startingBase, endingBase, units)
  if units == 0 then return end
  --print("hi")
  
  local id = #movements + 1
  local movement = {id = id, startBase = startingBase, endBase = endingBase, units = units}
  --if bases[startingBase].owner == 1 then print("id is: " .. id) end
  table.insert(movements, id, movement) -- insert attack at the end of the attacks table
  
  bases[startingBase].attacking = false
  if bases[startingBase].owner == 1 then selectedUnits = 0 end
end

function Movement:resolveMovement(id)
  if bases[movements[id].startBase].owner == bases[movements[id].endBase].owner then
   bases[movements[id].endBase].units = bases[movements[id].endBase].units + 10
 elseif bases[movements[id].startBase].owner ~= bases[movements[id].endBase].owner then
   bases[movements[id].endBase].units = bases[movements[id].endBase].units - 10
 end
 if bases[movements[id].endBase].units < 0 then
  bases[movements[id].endBase].units = math.abs(bases[movements[id].endBase].units)
  bases[movements[id].endBase].owner = bases[movements[id].startBase].owner
  bases[movements[id].endBase].color, bases[movements[id].endBase].secondaryColor = bases[movements[id].startBase].color, bases[movements[id].startBase].secondaryColor
 end
 --if movements[id].units <= 0 then table.remove(movements,movement.id) end
end

local timer = 10
function Movement:update(dt)
  for _,movement in ipairs(movements) do
    if movement.units > 0 then
      if timer <= 0 then
        movement.units = movement.units - 10
        Movement:drawShips(movement.id)
        timer = 10
      else
        timer = timer - 1
      end
    else
      
    end
  
  end
end

function Movement:drawShips(id)
    local n = #ships + 1
  ships[n] = { x = bases[movements[id].startBase].body:getX() + tx, y = bases[movements[id].startBase].body:getY() + ty, units = units, radius = 2, color = bases[movements[id].startBase].color, alpha = 255, timer = 1, startingTX = tx, startingTY = ty, owner = bases[movements[id].startBase].owner, endBase = bases[movements[id].endBase].id}
  flux.to(ships[n], ships[n].timer, { x = bases[movements[id].endBase].body:getX() + tx, y = bases[movements[id].endBase].body:getY() + ty })
    :onupdate(function() 
        if ships[n].startingTX ~= tx then
          ships[n].x = ships[n].x - ships[n].startingTX + tx
          ships[n].y = ships[n].y - ships[n].startingTY + ty
          ships[n].startingTX = tx
          ships[n].startingTY = ty
        end
        --print(movements[id])
        --flux.to(ships[n], ships[n].timer, { x = bases[movements[id].endBase].body:getX() + tx, y = bases[movements[id].endBase].body:getY() + ty }) 
        ships[n].timer = ships[n].timer - love.timer.getDelta()
        --print(ships[n].timer)
        end)
    :oncomplete(function() Movement:resolveMovement(id) end)
    :after(ships[n], 2, { alpha = 0 })
end

function Movement:draw()
  --for _,attack in ipairs(attacks) do
    if #ships > 0 then
      for _,ship in ipairs(ships) do
        --love.graphics.printf(ship.units, ship.x -tx + 10, ship.y -ty - 15, 50, "center")
        if ship.owner == 1 or bases[ship.endBase].owner == 1 then
          r,g,b = unpack(ship.color)
          love.graphics.setColor(r,g,b, ship.alpha)
          love.graphics.circle("fill", ship.x -tx, ship.y - ty, ship.radius)
        end
      end
    end
  --end
end

return Movement