Player = {}

local timer = 1
local bases = Bases:getBases()
local playerBase = 0

function Player:load()
  -- Which base will the player start at?
  local randomBase = love.math.random(1, #bases)
  Player:setPlayerBase(randomBase)
end

function Player:update(dt)
  for _,base in ipairs(bases) do
    if base.units < 1000 then
      if base.owner == 1 and base.timer <= 0 then
        base.units = base.units + 1
      end
      if base.timer <= 0 then
        base.timer = 1
      else
        base.timer = base.timer - (dt * base.offenseMod) * 5
      end
    elseif base.units > 1000 then
      base.units = 1000
    end
  end
end

function Player:draw()
end

function Player:setPlayerBase(id)
  bases[id].owner = 1
  bases[id].units = bases[id].units + 100
  bases[id].selected = true
  bases[id].specialty = {}
  bases[id].color = {0,0,255}
  bases[id].secondaryColor = {64,64,255}
  playerBase = id
  selectedBase = playerBase -- start with the player's base selected
  selectedPositionX = bases[id].body:getX()
  selectedPositionY = bases[id].body:getY()
  table.insert(bases[id].specialty, "capitol")
end


function Player:getPlayerBase()
  return playerBase
end

return Player