UI = {}

local panel_width = 330
local panel_height = 72
local button_width = 64
local button_height = 64

local base = {}
local buttons = {}
local text = ""

function UI:load() 
buttons.capitol = {}
buttons.capitol.color = {255,255,255}
buttons.capitol.alpha = 255
buttons.capitol.text = ""
buttons.capitol.description = "This is your Capitol.  It cannot be moved or purchased"
buttons.capitol.cost = 1000000
buttons.capitol.body =  love.physics.newBody(world, window_width / 2 - 128, 32, "dynamic")
buttons.capitol.shape = love.physics.newRectangleShape(64, 64)
buttons.capitol.fixture = love.physics.newFixture(buttons.capitol.body, buttons.capitol.shape)
buttons.capitol.image = love.graphics.newImage("assets/images/capitol.png")
buttons.capitol.fixture:setUserData("capitol")
--buttons.capitol.fixture:setSensor(true)

buttons.defense = {}
buttons.defense.color = {255,255,255}
buttons.defense.alpha = 255
buttons.defense.text = ""
buttons.defense.description = "Boost base defense 10%"
buttons.defense.cost = 100
buttons.defense.body =  love.physics.newBody(world, window_width / 2 - 64, 32, "dynamic")
buttons.defense.shape = love.physics.newRectangleShape(64, 64)
buttons.defense.fixture = love.physics.newFixture(buttons.defense.body, buttons.defense.shape)
buttons.defense.image = love.graphics.newImage("assets/images/defense.png")
buttons.defense.fixture:setUserData("defense")

buttons.offense = {}
buttons.offense.color = {255,255,255}
buttons.offense.alpha = 255
buttons.offense.text = ""
buttons.offense.description = "Boost unit production 20%"
buttons.offense.cost = 200
buttons.offense.body =  love.physics.newBody(world, window_width / 2, 32, "dynamic")
buttons.offense.shape = love.physics.newRectangleShape(64, 64)
buttons.offense.fixture = love.physics.newFixture(buttons.offense.body, buttons.offense.shape)
buttons.offense.image = love.graphics.newImage("assets/images/offense.png")
buttons.offense.fixture:setUserData("offense")

buttons.production = {}
buttons.production.color = {100,100,100}
buttons.production.alpha = 255
buttons.production.text = ""
buttons.production.description = "Boost base defense and unit production 15%"
buttons.production.cost = 2500
buttons.production.body =  love.physics.newBody(world, window_width / 2 + 64, 32, "dynamic")
buttons.production.shape = love.physics.newRectangleShape(64, 64)
buttons.production.fixture = love.physics.newFixture(buttons.production.body, buttons.production.shape)
buttons.production.image = love.graphics.newImage("assets/images/production.png")
buttons.production.fixture:setUserData("production")

buttons.healing = {}
buttons.healing.color = {100,100,100}
buttons.healing.alpha = 255
buttons.healing.text = ""
buttons.healing.description = "Immediately restore maximum health at all bases"
buttons.healing.cost = 10000
buttons.healing.body =  love.physics.newBody(world, window_width / 2 + 128, 32, "dynamic")
buttons.healing.shape = love.physics.newRectangleShape(64, 64)
buttons.healing.fixture = love.physics.newFixture(buttons.healing.body, buttons.healing.shape)
buttons.healing.image = love.graphics.newImage("assets/images/healing.png")
buttons.healing.fixture:setUserData("healing")
end

function UI:update(dt)
  base = Bases:getSelectedBase()
  for k,v in pairs(buttons) do
   UI:getHovering(k)
   --print(k)
  end
end

function UI:draw()
  for k,v in pairs(buttons) do
    --love.graphics.rectangle("line",v.fixture:getBoundingBox())
    if bases[selectedBase].owner == 1 then
      if Utils:tableHas(bases[selectedBase].specialty, k) then
        v.color = bases[selectedBase].color
      elseif Utils:tableHas(bases[selectedBase].specialty, k) == false and bases[selectedBase].units > v.cost then
        v.color = {255, 255, 255, 255}
      elseif bases[selectedBase].units < v.cost then
        v.color = {128, 128, 128, 255}
      end
      love.graphics.setColor(v.color)
    else
      v.color = { 64, 64, 64, 255 }
    end    
    love.graphics.setColor(v.color)
    love.graphics.draw(v.image, v.body:getX(),v.body:getY(),0,1,1,v.image:getWidth()/2, v.image:getHeight()/2)
    love.graphics.setColor(255,255,255,255)
    love.graphics.printf(v.text, window_width / 2 - 170 , 70, 340, "center")
  end
  --love.graphics.setColor(255,255,255,255)
end


function UI:getHovering(id)
  local mouseOver = buttons[id].shape:testPoint( buttons[id].body:getX(), buttons[id].body:getY(), 0, love.mouse.getX() * scaleX, love.mouse.getY() * scaleY)
  if mouseOver then
    buttons[id].alpha = 128
    buttons[id].text = buttons[id].description .. "\n" 
    if id ~= "capitol" then
      buttons[id].text = buttons[id].text  .. id .. " Cost: " .. buttons[id].cost
    end
    return true
  else
    buttons[id].alpha = 255
    buttons[id].text = ""
  end
  return
end

function UI:getButtons()
  return buttons
end

return UI